#!/usr/bin/perl

sub scanfile {
    my($seqnum,$filename)=@_;
    my($logentry,$errors,$errormsg,$basetime,$date,$rand,$diagnose,$subject,$mailto,$mailfrom,$logerrors,$filedata,$notifymsg,@mailto);
    chomp($seqnum);
    chomp($filename);
    $filename=$cgatedir.$filename;
    $queue=$cgatedir."Queue/";

    $diagnose=`$vscan "$filename"`;
    # Delete the "Thank You" message from the end of the diagnose program.
    $diagnose=~s/Thank.*//sgi;
    # If $diagnose contains some paths (or, more obviously "Found"), it's got a virus.
    if ($diagnose=~/^$cgatedir/ || $diagnose=~/Found/i) {
        # Prepare errors for bounced email;
        $errors=$diagnose;
        $errors=~s/\n/\\e/sg;
        $errors=~s|$queue||sgi;
        
		# Delete the paths, leaving only the error messages. - For the logfile.
        $logerrors=$diagnose;
        $logerrors=~s/^\s*\/.*?\n//gi;
        $logerrors=~s/\n/\,/sgi;
		$logerrors=~s/(found the |virus \!\!\!)//sgi;
        $logerrors=~s/\s//sgi;
        $logerrors=~s/\,$//;
        $filedata=`head -n 100 "$filename"`;
        # Extract some useful to/from/subject information for logging.
		$filedata=~/P\sI.*?\<([^\>]*)\>/s;
        $mailfrom=$1;
		while ($filedata=~/R\sW.*?\<([^\>]*)\>/sg){
			push (@mailto,$1);
		}
        $mailto=join(" ",@mailto);
        $filedata=~/Subject\s*\:([^\n]*)\n/i;
        $subject=$1;
        # Reject and Log
        $errormsg=$efcontents; $errormsg=~s/\n/\\e/gsi; $errormsg=~s/\"/\\"/sgi;
        $errormsg=~s/RESULTSHERE/$errors/si; $errormsg=~s/SUBJECTHERE/$subject/si; $errormsg=~s/TOHERE/$mailto/si; $errormsg=~s/FROMHERE/$mailfrom/si;
        # Log this thing.
        $date=`date`; chomp($date);

    	# Next line is commented to prevent archiving of viruses
		# system "cp","$filename","$virusdir/";
		

		# Next 3 Lines commented to prevent additional logging
        # open OUTPUT, ">> $logfile";
		# print OUTPUT "$date: $filename,$logerrors,$mailfrom,$mailto\n";
        # close OUTPUT;
	
	# Added notification s seiz #####
	$diagnose=~s|$queue||sgi;
	foreach $mailto (@mailto){
		$notifymsg=$ncontents; $notifymsg=~s/RESULTSHERE/$diagnose/si; $notifymsg=~s/TOHERE/$mailto/si; 
		$notifymsg=~s/FROMHERE/$mailfrom/si; $notifymsg=~s/SUBJECTHERE/$subject/si;
		
		open NEMAIL, "| mail -s 'VIRUS-Warning ($subject)' -f $notifyfrom -b $notifybcc $mailto";
		print NEMAIL $notifymsg;
		close (NEMAIL);  
	}
	# #### end added
        
	#Finally, reject it.
		if ($bounces==1){
        	print "$seqnum ERROR \"$errormsg\"\n";
        }
        else{
        	print "$seqnum DISCARD  \"$errormsg\"\n";
        }
    } else {
        # There's nothing wrong, or it wasn't a file scan request.
        print "$seqnum OK\n";
    }
}

1;

